//#include "stdafx.h"
#include "KBM3694SL.H"


/*****************************************************************************
  HANDLE KBM_Open(LPCTSTR strPort)

  strPort : VA|[g\(:"COM1")
  Baud    : {[[g
            (CBR_4800, CBR_9600, CBR_14400, CBR_19200, CBR_38400, 
             CBR_57600) 
  ߂l  : INVALID_HANDLE_VALUE G[

  VA|[gI[vAfoCXƂ̒ʐM܂B
  ߂l INVALID_HANDLE_VALUE ̏ꍇAGetLastError()ɂăG[R[h
  擾ł܂B
*****************************************************************************/

HANDLE KBM_Open(LPCTSTR strPort,DWORD Baud)
{
  DWORD Error;
  HANDLE hSer;

  //w̃VA|[gI[v܂B
  hSer = CreateFile(strPort,GENERIC_READ | GENERIC_WRITE,
      0, NULL, OPEN_EXISTING, 0, NULL);
  if(hSer == INVALID_HANDLE_VALUE) return hSer;

  //|[g̐ݒs܂B
  DCB dcb;
  if(!GetCommState(hSer,&dcb)){
    Error = GetLastError();
    CloseHandle(hSer);
    SetLastError(Error);
    return INVALID_HANDLE_VALUE;
  }
  dcb.BaudRate = Baud;
  dcb.fParity = TRUE;
  dcb.Parity = EVENPARITY;
  dcb.StopBits = ONESTOPBIT;
  dcb.ByteSize = 8;
  
  if(!SetCommState(hSer,&dcb)){
    Error = GetLastError();
    CloseHandle(hSer);
    SetLastError(Error);
    return INVALID_HANDLE_VALUE;
  }

  //|[g̃^CAEgݒ肵܂B
  COMMTIMEOUTS timeouts = { 0,0,2000,0,2000 };
  if(!SetCommTimeouts(hSer,&timeouts)){
    Error = GetLastError();
    CloseHandle(hSer);
    SetLastError(Error);
    return INVALID_HANDLE_VALUE;
  }
  return hSer;
}


/*****************************************************************************
  int KBM_EchoTest(HANDLE hDev)

  hDev   :  foCX̃nh

  ߂l :  0 I
           -1 |[g̃[h/CgŃG[ꍇ
           -2 GR[MłȂꍇ

  GR[R}h𑗂ĉ邩ׂ܂B
  ߂l-1̏ꍇAGetLastError()ɂăG[R[h擾ł܂B
*****************************************************************************/

int KBM_EchoTest(HANDLE hDev)
{
  DWORD n;
  BYTE bTBuff = KBM_CMD_ECHO;
  BYTE bRBuff = 0x00;

  if(!WriteFile(hDev,&bTBuff,1,&n,NULL)) return -1;
  if(!ReadFile(hDev,&bRBuff,1,&n,NULL)) return -1;
  if(n != 1 || bRBuff != KBM_CMD_ECHO) return -2;

  return 0;
}


/*****************************************************************************
  BYTE KBM_RecoverComErr(HANDLE hDev)

  hDev   : VA|[g̃nh

  ߂l : 0     񕜂Ɏs
           0ȊO 񕜂G[Xe[^X̃tOrbg܂
                 KBM_ERR_OVERRUN  I[o[G[
                 KBM_ERR_FRAMING  t[~OG[
                 KBM_ERR_PARITY   peBG[

  foCXƂ̃VAʐM̉񕜂݂܂B
*******************************************************************************/

BYTE KBM_RecoverComErr(HANDLE hDev)
{
  BYTE cmd = KBM_CMD_READ_STATUS;
  BYTE bRBuff;
  BYTE Status;
  DWORD n;

  //Xe[^X[h2x
  if(!WriteFile(hDev,&cmd,1,&n,NULL)) return 0;
  if(!ReadFile(hDev,&bRBuff,1,&n,NULL)) return 0;
  if(n != 1) return 0;
  if(bRBuff != KBM_CMD_ACK) return 0;

  if(!ReadFile(hDev,&bRBuff,1,&n,NULL)) return 0;
  if(n != 1) return FALSE;
  Status = bRBuff;  //Xe[^Xۑ

  if(!WriteFile(hDev,&cmd,1,&n,NULL)) return 0;
  if(!ReadFile(hDev,&bRBuff,1,&n,NULL)) return 0;
  if(n != 1) return 0;
  if(bRBuff != KBM_CMD_ACK) return 0;

  if(!ReadFile(hDev,&bRBuff,1,&n,NULL)) return 0;
  if(n != 1) return 0;
  if(bRBuff & KBM_ERR_MASK) return 0;
  return Status;  //G[rbgĂꍇA
}


/*****************************************************************************
  int KBM_SendByte(HANDLE hDev,BYTE Data)

  hDev   : VA|[g̃nh
  Data   : Mf[^

  ߂l :  0 I
           -1 VA|[g̃ANZXŃG[ꍇ
           -2 ʐMG[ꍇ
           -3 ʐMG[ߤfoCXG[[vɓꍇ

  foCX1oCg̃f[^𑗐M܂BȂꍇ͍đ
  s܂B
*****************************************************************************/

int KBM_SendByte(HANDLE hDev,BYTE Data)
{
  int i;
  DWORD n;
  BYTE bRBuff;

  for(i=0;i<2;i++){
    if(!WriteFile(hDev,&Data,1,&n,NULL)) return -1;
    if(!ReadFile(hDev,&bRBuff,1,&n,NULL)) return -1;
    if(n != 1) return -2; //MłȂꍇ

    switch(bRBuff){
    case KBM_CMD_ACK: //R}h̏ꍇ
      return 0;
    case KBM_CMD_RESEND: //đv̏ꍇ
      continue;
    case KBM_CMD_COM_ERR: //ʐMG[Ԃꍇ
      return -3;
    default:
      return -2;
    }
  }
  return -2;
}

  
/*****************************************************************************
  int KBM_WriteCmd(HANDLE hDev,BYTE Cmd,BYTE Data)

  hDev     : VA|[g̃nh
  Cmd      : R}h
  Data     : f[^

  ߂l   :  0 I
             -1 VA|[g̃ANZXŃG[ꍇ
             -2 ʐMG[ꍇ
             -3 ʐMG[ߤfoCXG[[vɓꍇ

  1oCg̃f[^ރR}h𑗂܂B
*****************************************************************************/

int KBM_WriteCmd(HANDLE hDev,BYTE Cmd,BYTE Data)
{
  int ret;

  if(ret = KBM_SendByte(hDev,Cmd)) return ret;
  if(ret = KBM_SendByte(hDev,Data)) return ret;

  return 0;
}


/*****************************************************************************
  int KBM_ReadCmd(HANDLE hDev,BYTE Cmd,BYTE *pData)

  hDev     : VA|[g̃nh
  Cmd      : R}h
  pData    : f[^̊i[

  ߂l   :  0 I
             -1 VA|[g̃ANZXŃG[ꍇ
             -2 ʐMG[ꍇ
             -3 ʐMG[ߤfoCXG[[vɓ

  1oCg̃f[^ǂݏoR}h𑗂܂B
*****************************************************************************/

int KBM_ReadCmd(HANDLE hDev,BYTE Cmd,BYTE *pData)
{
  int ret;
  DWORD n;

  if(ret = KBM_SendByte(hDev,Cmd)) return ret;
  if(!ReadFile(hDev,pData,1,&n,NULL)) return -1;
  if(n != 1) return -2;
  return 0;
}


/*****************************************************************************
  int KBM_SetDefault(HANDLE hDev)

  hDev     : VA|[g̃nh
  ߂l   :  0 I
             -1 VA|[g̃ANZXŃG[ꍇ
             -2 ʐMG[ꍇ
             -3 ʐMG[ߤfoCXG[[vɓꍇ

  N̏Ԃɖ߂܂B
*****************************************************************************/

int KBM_SetDefault(HANDLE hDev)
{
  return KBM_SendByte(hDev,KBM_CMD_SET_DEFAULT);
}


/*****************************************************************************
  int KBM_ReadVersion(HANDLE hDev,BYTE *pVer)

  hDev     : VA|[g̃nh
  pVer     : o[W̊i[

  ߂l   :  0 I
             -1 VA|[g̃ANZXŃG[ꍇ
             -2 ʐMG[ꍇ
             -3 ʐMG[ߤfoCXG[[vɓ

  t@[EFÃo[Wǂݎ܂B4rbgW[io[A
  4rbg}Ci[io[łB
*****************************************************************************/

int KBM_ReadVersion(HANDLE hDev,BYTE *pVer)
{
  return KBM_ReadCmd(hDev,KBM_CMD_READ_VERSION,pVer);
}


/*****************************************************************************
  int KBM_LCDInitialize(HANDLE hDev)

  hDev     : VA|[g̃nh

  ߂l   :  0 I
             -1 VA|[g̃ANZXŃG[ꍇ
             -2 ʐMG[ꍇ
             -3 ʐMG[ߤfoCXG[[vɓꍇ

  PIOLCDC^tF[Xɐݒ肳ĂꍇLCD̏s܂B
  ȊOł͉s܂B
*****************************************************************************/

int KBM_LCDInitialize(HANDLE hDev)
{
  return KBM_SendByte(hDev,KBM_CMD_LCD_INIT);
}


/*****************************************************************************
  int KBM_LCDLoadCGData(HANDLE hDev)

  hDev     : VA|[g̃nh

  ߂l   :  0 I
             -1 VA|[g̃ANZXŃG[ꍇ
             -2 ʐMG[ꍇ
             -3 ʐMG[ߤfoCXG[[vɓꍇ

  tbVCGRAMpf[^GAf[^ǂݏoāALCDCGRAMGA
  ɃRs[܂B
*****************************************************************************/

int KBM_LCDLoadCGData(HANDLE hDev)
{
  return KBM_SendByte(hDev,KBM_CMD_LCD_CGLOAD);
}


/*****************************************************************************
  int KBM_LCDWriteData(HANDLE hDev,BYTE Data)

  hDev     : VA|[g̃nh
  Data     : ރf[^

  ߂l   :  0 I
             -1 VA|[g̃ANZXŃG[ꍇ
             -2 ʐMG[ꍇ
             -3 ʐMG[ߤfoCXG[[vɓꍇ

  PIOLCDC^tF[Xɐݒ肳ĂꍇCGRAM܂DDRAMɑ΂ď
  ݂s܂BȊOł͉s܂B
*****************************************************************************/

int KBM_LCDWriteData(HANDLE hDev,BYTE Data)
{
  return KBM_WriteCmd(hDev,KBM_CMD_LCD_DWRITE,Data);
}


/*****************************************************************************
  int KBM_LCDWriteReg(HANDLE hDev,BYTE Data)

  hDev     : VA|[g̃nh
  Data     : ރf[^

  ߂l   :  0 I
             -1 VA|[g̃ANZXŃG[ꍇ
             -2 ʐMG[ꍇ
             -3 ʐMG[ߤfoCXG[[vɓꍇ

  PIOLCDC^tF[Xɐݒ肳ĂꍇWX^ɑ΂ď݂s
  ܂BȊOł͉s܂B
*****************************************************************************/

int KBM_LCDWriteReg(HANDLE hDev,BYTE Data)
{
  return KBM_WriteCmd(hDev,KBM_CMD_LCD_RWRITE,Data);
}


/*****************************************************************************
  int KBM_LCDReadData(HANDLE hDev,BYTE *pData)

  hDev     : VA|[g̃nh
  pData    : f[^̊i[

  ߂l   :  0 I
             -1 VA|[g̃ANZXŃG[ꍇ
             -2 ʐMG[ꍇ
             -3 ʐMG[ߤfoCXG[[vɓꍇ

  PIOLCDC^tF[Xɐݒ肳ĂꍇCGRAM܂DDRAMf[^
  ݏo܂BȊȌꍇ*pDataɂ͏0xffԂ܂B
*****************************************************************************/

int KBM_LCDReadData(HANDLE hDev,BYTE *pData)
{
  return KBM_ReadCmd(hDev,KBM_CMD_LCD_DREAD,pData);
}


/*****************************************************************************
  int KBM_LCDReadReg(HANDLE hDev,BYTE *pData)

  hDev     : VA|[g̃nh
  pData    : f[^̊i[

  ߂l   :  0 I
             -1 VA|[g̃ANZXŃG[ꍇ
             -2 ʐMG[ꍇ
             -3 ʐMG[ߤfoCXG[[vɓꍇ

  PIOLCDC^tF[Xɐݒ肳ĂꍇWX^f[^ǂݏo
  ȊȌꍇ*pDataɂ͏0xffԂ܂B
*****************************************************************************/

int KBM_LCDReadReg(HANDLE hDev,BYTE *pData)
{
  return KBM_ReadCmd(hDev,KBM_CMD_LCD_RREAD,pData);
}


/*****************************************************************************
  int KBM_PIOWrite(HANDLE hDev,BYTE Data)

  hDev     : VA|[g̃nh
  Data     : ރf[^

  ߂l   :  0 I
             -1 VA|[g̃ANZXŃG[ꍇ
             -2 ʐMG[ꍇ
             -3 ʐMG[ߤfoCXG[[vɓꍇ

  PIOɒl݂܂Bo͂ɐݒ肳Ărbg͏񂾒lf
  ܂BPIOLCDC^tF[Xɐݒ肳Ăꍇs܂B
*****************************************************************************/

int KBM_PIOWrite(HANDLE hDev,BYTE Data)
{
  return KBM_WriteCmd(hDev,KBM_CMD_PIO_WRITE,Data);
}


/*****************************************************************************
  int KBM_PIOSetDir(HANDLE hDev,BYTE Bits)

  hDev     : VA|[g̃nh
  Bits     : (1̃rbg:oͤ0̃rbg:)

  ߂l   :  0 I
             -1 VA|[g̃ANZXŃG[ꍇ
             -2 ʐMG[ꍇ
             -3 ʐMG[ߤfoCXG[[vɓꍇ

  PIO̓o͂؂ւ܂BPIOLCDC^tF[Xɐݒ肳Ăꍇ
  s܂B
*****************************************************************************/

int KBM_PIOSetDir(HANDLE hDev,BYTE Bits)
{
  return KBM_WriteCmd(hDev,KBM_CMD_PIO_DIR,Bits);
}


/*****************************************************************************
  int KBM_POWrite(HANDLE hDev,BYTE Data)

  hDev     : VA|[g̃nh
  Data     : ރf[^

  ߂l   :  0 I
             -1 VA|[g̃ANZXŃG[ꍇ
             -2 ʐMG[ꍇ
             -3 ʐMG[ߤfoCXG[[vɓꍇ

  POɒl݂܂BDatȁ4rbgPO4-PO7ɔf܂B
  PO4-PO7L[{[hpROWo͂ɐݒ肳Ăꍇs܂B
*****************************************************************************/

int KBM_POWrite(HANDLE hDev,BYTE Data)
{
  return KBM_WriteCmd(hDev,KBM_CMD_PO_WRITE,Data);
}


/*****************************************************************************
  int KBM_PIORead(HANDLE hDev,BYTE *pData)

  hDev     : VA|[g̃nh
  pData    : f[^̊i[

  ߂l   :  0 I
             -1 VA|[g̃ANZXŃG[ꍇ
             -2 ʐMG[ꍇ
             -3 ʐMG[ߤfoCXG[[vɓꍇ

  PIOf[^ǂݏo܂BPIOLCDC^tF[Xɐݒ肳Ăꍇ
  *pData̒l͕słB
*****************************************************************************/

int KBM_PIORead(HANDLE hDev,BYTE *pData)
{
  return KBM_WriteCmd(hDev,KBM_CMD_PIO_READ,*pData);
}


/*****************************************************************************
  int KBM_PORead(HANDLE hDev,BYTE *pData)

  hDev     : VA|[g̃nh
  pData    : f[^̊i[

  ߂l   :  0 I
             -1 VA|[g̃ANZXŃG[ꍇ
             -2 ʐMG[ꍇ
             -3 ʐMG[ߤfoCXG[[vɓꍇ

  POo͒̃f[^ǂݏo܂B4rbgLłB
*****************************************************************************/

int KBM_PORead(HANDLE hDev,BYTE *pData)
{
  return KBM_ReadCmd(hDev,KBM_CMD_PO_READ,pData);
}


/*****************************************************************************
  int KBM_PIRead(HANDLE hDev,BYTE *pData)

  hDev     : VA|[g̃nh
  pData    : f[^̊i[

  ߂l   :  0 I
             -1 VA|[g̃ANZXŃG[ꍇ
             -2 ʐMG[ꍇ
             -3 ʐMG[ߤfoCXG[[vɓꍇ

  POf[^ǂݏo܂B
*****************************************************************************/

int KBM_PIRead(HANDLE hDev,BYTE *pData)
{
  return KBM_ReadCmd(hDev,KBM_CMD_PI_READ,pData);
}


/*****************************************************************************
  int KBM_WriteOption(HANDLE hDev,WORD Option)

  hDev     : VA|[g̃nh
  Option   : IvV
             KBM_OPT_NO_BAT  : PS/2|[gɋNBATIR[hoȂ
             KBM_OPT_ALL_ACK : PS/2|[g̎ʂłȂR}hɂACKԂ
             KBM_OPT_LCD_ENB : PIOLCDƂĎgp
             KBM_OPT_PO_OUT  : PO4-PO7o̓|[gƂĎgp
             KBM_OPT_PI_SCAN : PI0-PI7COLƂăXL܂

  ߂l   :  0 I
             -1 VA|[g̃ANZXŃG[ꍇ
             -2 ʐMG[ꍇ
             -3 ʐMG[ߤfoCXG[[vɓꍇ

  IvVݒ肵܂B̃IvVݒ肷ɂORŌĂ
  B
*****************************************************************************/

int KBM_WriteOption(HANDLE hDev,WORD Option)
{
  int ret;

  if((ret = KBM_WriteCmd(hDev,KBM_CMD_SET_MODE0,(BYTE)Option))) return ret;
  return KBM_WriteCmd(hDev,KBM_CMD_SET_MODE1,(BYTE)(Option >> 8));
}


/*****************************************************************************
  int KBM_ReadOption(HANDLE hDev,WORD *pOption)

  hDev     : VA|[g̃nh
  pOption  : IvV̊i[
             KBM_OPT_NO_BAT  : PS/2|[gɋNBATIR[hoȂ
             KBM_OPT_ALL_ACK : PS/2|[g̎ʂłȂR}hɂACKԂ
             KBM_OPT_LCD_ENB : PIOLCDƂĎgp
             KBM_OPT_PO_OUT  : PO4-PO7o̓|[gƂĎgp
             KBM_OPT_PI_SCAN : PI0-PI7COLƂăXL܂

  ߂l   :  0 I
             -1 VA|[g̃ANZXŃG[ꍇ
             -2 ʐMG[ꍇ
             -3 ʐMG[ߤfoCXG[[vɓꍇ

  ݂̓IvVǂݏo܂B
*****************************************************************************/

int KBM_ReadOption(HANDLE hDev,WORD *pOption)
{
  int ret;
  BYTE bTmp;
  
  *pOption = 0x0000;

  if(ret = KBM_ReadCmd(hDev,KBM_CMD_READ_MODE0,&bTmp)) return ret;
  *pOption = bTmp;
  if(ret = KBM_ReadCmd(hDev,KBM_CMD_READ_MODE1,&bTmp)) return ret;
  *pOption |= ((WORD)bTmp << 8);
  return 0;
}


/*****************************************************************************
  int KBM_ReadStatus(HANDLE hDev,BYTE *pStatus)

  hDev     : VA|[g̃nh
  pStatus  : Xe[^X̊i[椃Xe[^Xɂ͉̃rbg܂
             KBM_ERR_OVERRUN  I[o[G[
             KBM_ERR_FRAMING  t[~OG[
             KBM_ERR_PARITY   peBG[
             KBM_ERR_TIMEOUT  ^CAEg
             KBM_STS_ENABLE   L[XL

  ߂l   :  0 I
             -1 VA|[g̃ANZXŃG[ꍇ
             -2 ʐMG[ꍇ
             -3 ʐMG[ߤfoCXG[[vɓꍇ

  foCX̃Xe[^Xǂݏo܂B
*****************************************************************************/

int KBM_ReadStatus(HANDLE hDev,BYTE *pStatus)
{
  return KBM_ReadCmd(hDev,KBM_CMD_READ_STATUS,pStatus);
}


/*****************************************************************************
  int KBM_ADRead(HANDLE hDev,BYTE ch,long *pData)

  hDev     : VA|[g̃nh
  ch       : AD̃`l(0`7)
  pData    : f[^̊i[

  ߂l   :  0 I
             -1 VA|[g̃ANZXŃG[ꍇ
             -2 ʐMG[ꍇ
             -3 ʐMG[ߤfoCXG[[vɓꍇ

  w`lADϊʂԂ܂B
*****************************************************************************/

int KBM_ADRead(HANDLE hDev,BYTE ch,long *pData)
{
  DWORD n;
  int ret;
  WORD wTmp;

  if(ret = KBM_WriteCmd(hDev,KBM_CMD_AD_READ,(BYTE)ch)) return ret;
  if(!ReadFile(hDev,&wTmp,2,&n,NULL)) return -1;
  if(n < 2) return -2;
  *pData = wTmp;
  return 0;
}


/*****************************************************************************
  int KBM_Enable(HANDLE hDev)

  hDev     : VA|[g̃nh
  ߂l   :  0 I
             -1 VA|[g̃ANZXŃG[ꍇ
             -2 ʐMG[ꍇ
             -3 ʐMG[ߤfoCXG[[vɓꍇ

  L[XL܂B
*****************************************************************************/

int KBM_Enable(HANDLE hDev)
{
  return KBM_SendByte(hDev,KBM_CMD_ENABLE);
}


/*****************************************************************************
  int KBM_Disable(HANDLE hDev)

  hDev     : VA|[g̃nh
  ߂l   :  0 I
             -1 VA|[g̃ANZXŃG[ꍇ
             -2 ʐMG[ꍇ
             -3 ʐMG[ߤfoCXG[[vɓꍇ

  L[XL֎~܂B
*****************************************************************************/

int KBM_Disable(HANDLE hDev)
{
  return KBM_SendByte(hDev,KBM_CMD_DISABLE);
}